﻿using ProtoBuf;

namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        Message sourceMessage = new Message
        {
            MessageID = "A49EC1E0-5F84-4DBA-9DF3-A8605407770F",
            Priority  = 100,
            Text      = "텍스트 문자열 입니다."
        };

        Console.WriteLine("소스 메시지");
        Console.WriteLine($"{sourceMessage.MessageID}, {sourceMessage.Priority}, {sourceMessage.Text}");
        Console.WriteLine();

        MemoryStream serializingStream = new MemoryStream();

        Serializer.Serialize<Message>(serializingStream, sourceMessage);

        byte[] serializedByteArray = serializingStream.ToArray();

        Console.WriteLine("직렬화 바이트 배열");
        Console.WriteLine($"{BitConverter.ToString(serializedByteArray)}");
        Console.WriteLine();

        MemoryStream deserializingStream = new MemoryStream(serializedByteArray);

        Message deserializedMessage = Serializer.Deserialize<Message>(deserializingStream);

        Console.WriteLine("역직렬화 메시지");
        Console.WriteLine($"{deserializedMessage.MessageID}, {deserializedMessage.Priority}, {deserializedMessage.Text}");
        Console.WriteLine();

        Console.WriteLine("프로그램을 종료하기 위해서 아무 키나 눌러 주시기 바랍니다.");

        Console.ReadKey(false);
    }

    #endregion
}